From 464aeeb515591e89dca8bf9a014ff73c045775f5 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 09 2020 03:14:06 +0000
Subject: [PATCH 1315/2232] Rust-defined methods on shared structs


---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 4c9ecd3..96f9b07 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -202,7 +202,7 @@ pub mod ffi {
         fn set2(&mut self, n: usize) -> usize;
         fn set_succeed(&mut self, n: usize) -> Result<usize>;
         fn get_fail(&mut self) -> Result<usize>;
-        fn method_on_shared(self: &Shared) -> usize;
+        fn c_method_on_shared(self: &Shared) -> usize;
 
         #[rust_name = "i32_overloaded_method"]
         fn cOverloadedMethod(&self, x: i32) -> String;
@@ -274,6 +274,7 @@ pub mod ffi {
         fn r_return_r2(n: usize) -> Box<R2>;
         fn get(self: &R2) -> usize;
         fn set(self: &mut R2, n: usize) -> usize;
+        fn r_method_on_shared(self: &Shared) -> usize;
 
         #[cxx_name = "rAliasedFunction"]
         fn r_aliased_function(x: i32) -> String;
@@ -316,6 +317,12 @@ impl R2 {
     }
 }
 
+impl ffi::Shared {
+    fn r_method_on_shared(&self) -> usize {
+        2020
+    }
+}
+
 #[derive(Debug)]
 struct Error;
 
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index b387bbb..fd4751e 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -35,7 +35,7 @@ size_t C::set_succeed(size_t n) { return this->set2(n); }
 
 size_t C::get_fail() { throw std::runtime_error("unimplemented"); }
 
-size_t Shared::method_on_shared() const noexcept { return 2021; }
+size_t Shared::c_method_on_shared() const noexcept { return 2021; }
 
 const std::vector<uint8_t> &C::get_v() const { return this->v; }
 
@@ -626,6 +626,7 @@ extern "C" const char *cxx_run_test() noexcept {
   ASSERT(r2->get() == 2021);
   ASSERT(r2->set(2020) == 2020);
   ASSERT(r2->get() == 2020);
+  ASSERT(Shared{0}.r_method_on_shared() == 2020);
 
   ASSERT(std::string(rAliasedFunction(2020)) == "2020");
 
diff --git a/tests/test.rs b/tests/test.rs
index 58fdd84..a2c64c3 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -193,7 +193,7 @@ fn test_c_method_calls() {
     assert_eq!(old_value, unique_ptr.get2());
     assert_eq!(2022, unique_ptr.set_succeed(2022).unwrap());
     assert!(unique_ptr.get_fail().is_err());
-    assert_eq!(2021, ffi::Shared { z: 0 }.method_on_shared());
+    assert_eq!(2021, ffi::Shared { z: 0 }.c_method_on_shared());
 }
 
 #[test]

